Package net.sf.saxon.jaxp

## Class SaxonTransformerFactory

- java.lang.Object
- - javax.xml.transform.TransformerFactory
  - - javax.xml.transform.sax.SAXTransformerFactory
    - - net.sf.saxon.jaxp.SaxonTransformerFactory

- All Implemented Interfaces:
    `Configuration.ApiProvider`
  Direct Known Subclasses:
    `TransformerFactoryImpl`

      public class SaxonTransformerFactory
      extends javax.xml.transform.sax.SAXTransformerFactory
      implements Configuration.ApiProvider

  A SaxonTransformerFactory instance can be used to create Transformer and Template objects.

  Although the class is public, it is not intended to be used directly by applications; applications should normally invoke the subclass `TransformerFactoryImpl`.

  The system property that determines which Factory implementation to create is named "javax.xml.transform.TransformerFactory". This property names a concrete subclass of the TransformerFactory abstract class. If the property is not defined, a platform default is be used.

  This implementation class implements the abstract methods on both the javax.xml.transform.TransformerFactory and javax.xml.transform.sax.SAXTransformerFactory classes.

  Since Saxon 9.6, the JAXP transformation interface is re-implemented as a layer on top of the s9api interface. This will affect applications that attempt to down-cast from JAXP interfaces to the underlying implementation classes.

- - ### Field Summary

    - ### Fields inherited from class javax.xml.transform.sax.SAXTransformerFactory

      `FEATURE, FEATURE_XMLFILTER`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SaxonTransformerFactory()` | Default constructor.
    `SaxonTransformerFactory​(Configuration config)` | Construct a TransformerFactory using an existing Configuration.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `javax.xml.transform.Source` | `getAssociatedStylesheet​(javax.xml.transform.Source source, java.lang.String media, java.lang.String title, java.lang.String charset)` | Get the stylesheet specification(s) associated via the xml-stylesheet processing instruction (see http://www.w3.org/TR/xml-stylesheet/) with the document document specified in the source parameter, and that match the given criteria.
    `java.lang.Object` | `getAttribute​(java.lang.String name)` | Allows the user to retrieve specific attributes on the underlying implementation.
    `Configuration` | `getConfiguration()` | Get the configuration.
    `javax.xml.transform.ErrorListener` | `getErrorListener()` | Get the error event handler for the TransformerFactory.
    `boolean` | `getFeature​(java.lang.String name)` | Look up the value of a feature.
    `Processor` | `getProcessor()` | Get the underlying s9api Processor.
    `javax.xml.transform.URIResolver` | `getURIResolver()` | Get the object that is used by default during the transformation to resolve URIs used in document(), xsl:import, or xsl:include.
    `javax.xml.transform.Templates` | `newTemplates​(javax.xml.transform.Source source)` | Process the Source into a Templates object, which is a a compiled representation of the source.
    `javax.xml.transform.Templates` | `newTemplates​(javax.xml.transform.Source source, CompilerInfo info)` | Process the Source into a Templates object, which is a a compiled representation of the source.
    `javax.xml.transform.sax.TemplatesHandler` | `newTemplatesHandler()` | Get a TemplatesHandler object that can process SAX ContentHandler events into a Templates object.
    `javax.xml.transform.Transformer` | `newTransformer()` | Create a new Transformer object that performs a copy of the source to the result.
    `javax.xml.transform.Transformer` | `newTransformer​(javax.xml.transform.Source source)` | Process the Source into a Transformer object.
    `javax.xml.transform.sax.TransformerHandler` | `newTransformerHandler()` | Get a TransformerHandler object that can process SAX ContentHandler events into a Result.
    `javax.xml.transform.sax.TransformerHandler` | `newTransformerHandler​(javax.xml.transform.Source src)` | Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the transformation instructions specified by the argument.
    `javax.xml.transform.sax.TransformerHandler` | `newTransformerHandler​(javax.xml.transform.Templates templates)` | Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the Templates argument.
    `org.xml.sax.XMLFilter` | `newXMLFilter​(javax.xml.transform.Source src)` | Create an XMLFilter that uses the given Source as the transformation instructions.
    `org.xml.sax.XMLFilter` | `newXMLFilter​(javax.xml.transform.Templates templates)` | Create an XMLFilter, based on the Templates argument..
    `void` | `setAttribute​(java.lang.String name, java.lang.Object value)` | Allows the user to set specific attributes on the underlying implementation.
    `void` | `setConfiguration​(Configuration config)` | Set the configuration.
    `void` | `setErrorListener​(javax.xml.transform.ErrorListener listener)` | Set the error event listener for the TransformerFactory, which is used for the processing of transformation instructions, and not for the transformation itself.
    `void` | `setFeature​(java.lang.String name, boolean value)` | Set a feature for this `TransformerFactory` and `Transformer`s or `Template`s created by this factory.
    `void` | `setURIResolver​(javax.xml.transform.URIResolver resolver)` | Set an object that is used by default during the transformation to resolve URIs used in xsl:import, or xsl:include.

    - ### Methods inherited from class javax.xml.transform.TransformerFactory

      `newDefaultInstance, newInstance, newInstance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SaxonTransformerFactory

          public SaxonTransformerFactory()

      Default constructor.

    - #### SaxonTransformerFactory

          public SaxonTransformerFactory​(Configuration config)

      Construct a TransformerFactory using an existing Configuration.
      Parameters:
        `config` - the Saxon configuration

  - ### Method Detail

    - #### setConfiguration

          public void setConfiguration​(Configuration config)

      Set the configuration. This can also be done using the JAXP method setAttribute, with the attribute name `FeatureKeys.CONFIGURATION`
      Parameters:
        `config` - the Saxon configuration

    - #### getConfiguration

          public Configuration getConfiguration()

      Get the configuration. This can also be done using the JAXP method getAttribute, with the attribute name `FeatureKeys.CONFIGURATION` This is a trapdoor method that provides access to underlying implementation details that may change in subsequent Saxon releases.
      Returns:
        the Saxon configuration

    - #### newTransformer

          public javax.xml.transform.Transformer newTransformer​(javax.xml.transform.Source source)
                                                         throws javax.xml.transform.TransformerConfigurationException

      Process the Source into a Transformer object. The Transformer object must not be used in multiple threads running concurrently. Different TransformerFactories can be used concurrently by different threads.
      Specified by:
        `newTransformer` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `source` - An object that holds a URI, input stream, etc. of the stylesheet used to perform the transformation.
      Returns:
        A Transformer object that may be used to perform a transformation in a single thread, never null.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - May throw this during the parse when it is constructing the Templates object and fails.

    - #### newTransformer

          public javax.xml.transform.Transformer newTransformer()

      Create a new Transformer object that performs a copy of the source to the result.
      Specified by:
        `newTransformer` in class `javax.xml.transform.TransformerFactory`
      Returns:
        A Transformer object that may be used to perform a transformation in a single thread, never null.

    - #### newTemplates

          public javax.xml.transform.Templates newTemplates​(javax.xml.transform.Source source)
                                                     throws javax.xml.transform.TransformerConfigurationException

      Process the Source into a Templates object, which is a a compiled representation of the source. This Templates object may then be used concurrently across multiple threads. Creating a Templates object allows the TransformerFactory to do detailed performance optimization of transformation instructions, without penalizing runtime transformation.
      Specified by:
        `newTemplates` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `source` - An object that holds a URL, input stream, etc.
      Returns:
        A Templates object capable of being used for transformation purposes, never null.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - May throw this during the parse when it is constructing the Templates object and fails.

    - #### newTemplates

          public javax.xml.transform.Templates newTemplates​(javax.xml.transform.Source source,
                                                            CompilerInfo info)
                                                     throws javax.xml.transform.TransformerConfigurationException

      Process the Source into a Templates object, which is a a compiled representation of the source. This Templates object may then be used concurrently across multiple threads. Creating a Templates object allows the TransformerFactory to do detailed performance optimization of transformation instructions, without penalizing runtime transformation.
      Parameters:
        `source` - An object that holds a URL, input stream, etc.
        `info` - compile-time options for this stylesheet compilation
      Returns:
        A Templates object capable of being used for transformation purposes, never null.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - May throw this during the parse when it is constructing the Templates object and fails.

    - #### getAssociatedStylesheet

          public javax.xml.transform.Source getAssociatedStylesheet​(javax.xml.transform.Source source,
                                                                    java.lang.String media,
                                                                    java.lang.String title,
                                                                    java.lang.String charset)
                                                             throws javax.xml.transform.TransformerConfigurationException

      Get the stylesheet specification(s) associated via the xml-stylesheet processing instruction (see http://www.w3.org/TR/xml-stylesheet/) with the document document specified in the source parameter, and that match the given criteria. Note that it is possible to return several stylesheets, in which case they are applied as if they were a list of imports or cascades.
      Specified by:
        `getAssociatedStylesheet` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `source` - The XML source document.
        `media` - The media attribute to be matched. May be null, in which case the prefered templates will be used (i.e. alternate = no). Note that Saxon does not implement the complex CSS3-based syntax for media queries. By default, the media value is simply ignored. An algorithm for comparing the requested media with the declared media can be defined using the method `Configuration.setMediaQueryEvaluator(Comparator)`.
        `title` - The value of the title attribute to match. May be null.
        `charset` - The value of the charset attribute to match. May be null.
      Returns:
        A Source object suitable for passing to the TransformerFactory.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - if any problems occur

    - #### setURIResolver

          public void setURIResolver​(javax.xml.transform.URIResolver resolver)

      Set an object that is used by default during the transformation to resolve URIs used in xsl:import, or xsl:include.
      Specified by:
        `setURIResolver` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `resolver` - An object that implements the URIResolver interface, or null.

    - #### getURIResolver

          public javax.xml.transform.URIResolver getURIResolver()

      Get the object that is used by default during the transformation to resolve URIs used in document(), xsl:import, or xsl:include.
      Specified by:
        `getURIResolver` in class `javax.xml.transform.TransformerFactory`
      Returns:
        The URIResolver that was set with setURIResolver.

    - #### getFeature

          public boolean getFeature​(java.lang.String name)

      Look up the value of a feature.

      The feature name is any absolute URI.

      Specified by:
        `getFeature` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `name` - The feature name, which is an absolute URI.
      Returns:
        The current state of the feature (true or false).

    - #### setAttribute

          public void setAttribute​(java.lang.String name,
                                   java.lang.Object value)
                            throws java.lang.IllegalArgumentException

      Allows the user to set specific attributes on the underlying implementation. An attribute in this context is defined to be an option that the implementation provides.

      Note: setting configuration properties using the method `Configuration.setConfigurationProperty(Feature, Object)` is more efficient, and gives better type safety.

      Specified by:
        `setAttribute` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `name` - The name of the attribute. This must be one of the constants defined in class `FeatureKeys`.
        `value` - The value of the attribute.
      Throws:
        `java.lang.IllegalArgumentException` - thrown if Saxon doesn't recognize the attribute.
      See Also:
        `FeatureKeys`

    - #### getAttribute

          public java.lang.Object getAttribute​(java.lang.String name)
                                        throws java.lang.IllegalArgumentException

      Allows the user to retrieve specific attributes on the underlying implementation.
      Specified by:
        `getAttribute` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `name` - The name of the attribute. This must be one of the constants defined in class `FeatureKeys`.
      Returns:
        value The value of the attribute.
      Throws:
        `java.lang.IllegalArgumentException` - thrown if the underlying implementation doesn't recognize the attribute.

    - #### setErrorListener

          public void setErrorListener​(javax.xml.transform.ErrorListener listener)
                                throws java.lang.IllegalArgumentException

      Set the error event listener for the TransformerFactory, which is used for the processing of transformation instructions, and not for the transformation itself.

      This method is defined in JAXP but its use with Saxon is deprecated, because the errorListener will be shared by all stylesheet compilations running under this factory, which may be operating concurrently in different threads.

      Specified by:
        `setErrorListener` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `listener` - The new error listener.
      Throws:
        `java.lang.IllegalArgumentException` - if listener is null.

    - #### getErrorListener

          public javax.xml.transform.ErrorListener getErrorListener()

      Get the error event handler for the TransformerFactory.
      Specified by:
        `getErrorListener` in class `javax.xml.transform.TransformerFactory`
      Returns:
        The current error listener, which should never be null.

    - #### newTransformerHandler

          public javax.xml.transform.sax.TransformerHandler newTransformerHandler​(javax.xml.transform.Source src)
                                                                           throws javax.xml.transform.TransformerConfigurationException

      Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the transformation instructions specified by the argument.
      Specified by:
        `newTransformerHandler` in class `javax.xml.transform.sax.SAXTransformerFactory`
      Parameters:
        `src` - The Source of the transformation instructions.
      Returns:
        TransformerHandler ready to transform SAX events.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - If for some reason the TransformerHandler can not be created.

    - #### newTransformerHandler

          public javax.xml.transform.sax.TransformerHandler newTransformerHandler​(javax.xml.transform.Templates templates)
                                                                           throws javax.xml.transform.TransformerConfigurationException

      Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the Templates argument.
      Specified by:
        `newTransformerHandler` in class `javax.xml.transform.sax.SAXTransformerFactory`
      Parameters:
        `templates` - The compiled transformation instructions.
      Returns:
        TransformerHandler ready to transform SAX events.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - If for some reason the TransformerHandler can not be created.

    - #### newTransformerHandler

          public javax.xml.transform.sax.TransformerHandler newTransformerHandler()

      Get a TransformerHandler object that can process SAX ContentHandler events into a Result. The transformation is defined as an identity (or copy) transformation, for example to copy a series of SAX parse events into a DOM tree.
      Specified by:
        `newTransformerHandler` in class `javax.xml.transform.sax.SAXTransformerFactory`
      Returns:
        A non-null reference to a TransformerHandler, that may be used as a ContentHandler for SAX parse events.

    - #### newTemplatesHandler

          public javax.xml.transform.sax.TemplatesHandler newTemplatesHandler()

      Get a TemplatesHandler object that can process SAX ContentHandler events into a Templates object.
      Specified by:
        `newTemplatesHandler` in class `javax.xml.transform.sax.SAXTransformerFactory`
      Returns:
        A non-null reference to a TransformerHandler, that may be used as a ContentHandler for SAX parse events.

    - #### newXMLFilter

          public org.xml.sax.XMLFilter newXMLFilter​(javax.xml.transform.Source src)
                                             throws javax.xml.transform.TransformerConfigurationException

      Create an XMLFilter that uses the given Source as the transformation instructions.
      Specified by:
        `newXMLFilter` in class `javax.xml.transform.sax.SAXTransformerFactory`
      Parameters:
        `src` - The Source of the transformation instructions.
      Returns:
        An XMLFilter object, or null if this feature is not supported.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - If for some reason the XMLFilter cannot be created.

    - #### newXMLFilter

          public org.xml.sax.XMLFilter newXMLFilter​(javax.xml.transform.Templates templates)
                                             throws javax.xml.transform.TransformerConfigurationException

      Create an XMLFilter, based on the Templates argument..
      Specified by:
        `newXMLFilter` in class `javax.xml.transform.sax.SAXTransformerFactory`
      Parameters:
        `templates` - The compiled transformation instructions.
      Returns:
        An XMLFilter object.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - if (for example) the `templates` object was not created by Saxon.

    - #### setFeature

          public void setFeature​(java.lang.String name,
                                 boolean value)
                          throws javax.xml.transform.TransformerConfigurationException

      Set a feature for this `TransformerFactory` and `Transformer`s or `Template`s created by this factory.

      Feature names are fully qualified `URI`s. Implementations may define their own features. An `TransformerConfigurationException` is thrown if this `TransformerFactory` or the `Transformer`s or `Template`s it creates cannot support the feature. It is possible for an `TransformerFactory` to expose a feature value but be unable to change its state.

      All implementations are required to support the FEATURE_SECURE_PROCESSING feature. When the feature is:

      - `true`: the implementation will limit XML processing to conform to implementation limits and behave in a secure fashion as defined by the implementation. Examples include resolving user defined style sheets and functions. If XML processing is limited for security reasons, it will be reported via a call to the registered `ErrorListener.fatalError(javax.xml.transform.TransformerException exception)`. See `setErrorListener(javax.xml.transform.ErrorListener listener)`. In the Saxon implementation, this option causes calls on extension functions and extensions instructions to be disabled, and also disables the use of xsl:result-document to write to secondary output destinations.
      - `false`: the implementation will processing XML according to the XML specifications without regard to possible implementation limits.
      Specified by:
        `setFeature` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `name` - Feature name.
        `value` - Is feature state `true` or `false`.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - if this `TransformerFactory` or the `Transformer`s or `Template`s it creates cannot support this feature.
        `java.lang.NullPointerException` - If the `name` parameter is null.

    - #### getProcessor

          public Processor getProcessor()

      Get the underlying s9api Processor. (Trapdoor method providing access to underlying implementation details which may change in subsequent releases)
      Returns:
        the processor
      Since:
        9.8.0.5